#version 430 core
#extension GL_EXT_gpu_shader4: enable // used for random generation

/*
* Copyright 2018 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;


uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

uniform float time;
void main() { 
	float time_f = 0.7*sin(time*5);
	float f = time_f  * sin(position.x/2) * sin(position.y/2) * sin(position.z/2)  ;
	//vec3 grad_f = sin(time*5) * vec3(	cos(position.x) * sin(position.y) * sin(position.z) ,
		//							cos(position.y) * sin(position.x) * sin(position.z) ,
			//						cos(position.z) * sin(position.x) * sin(position.y));

	vec3 X_u = vec3(-position.y, position.x, 0);
	vec3 X_v = vec3(0,0,1);

	vec3 Y_u = X_u * (1 + f) + position * time_f *  sin(position.z)* 
				( position.x * sin(position.x) * cos(position.y) - position.y * cos(position.x) * sin(position.y));
	vec3 Y_v = X_v * (1 + f) + position * time_f * cos(position.z);


	//vec3 normal_modified = 2*vec3(position.x, position.y, position.z) + grad_f;
	//normal_modified = normalize(normal_modified);
	vec3 normal_modified = normalize(cross(Y_u, Y_v));
	vert.normal_world = normalMatrix * normal_modified;

	vert.uv = uv;
	vec4 position_world_ = modelMatrix * vec4(position, 1);
	vert.position_world = position_world_.xyz;

	//vec3 P = vert.position_world + vert.normal_world * f ;

	vec3 P = vert.position_world*(1 + f);
	


	gl_Position = viewProjMatrix *  vec4(P, 1.0);

}